cfg.mk 37.2 KB
Newer Older
1
# Customize Makefile.maint.                           -*- makefile -*-
2
# Copyright (C) 2008-2013 Red Hat, Inc.
3
# Copyright (C) 2003-2008 Free Software Foundation, Inc.
4 5 6 7 8 9 10 11 12 13 14 15

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
16 17
# along with this program.  If not, see
# <http://www.gnu.org/licenses/>.
18 19 20 21 22 23 24 25 26 27 28

# Use alpha.gnu.org for alpha and beta releases.
# Use ftp.gnu.org for major releases.
gnu_ftp_host-alpha = alpha.gnu.org
gnu_ftp_host-beta = alpha.gnu.org
gnu_ftp_host-major = ftp.gnu.org
gnu_rel_host = $(gnu_ftp_host-$(RELEASE_TYPE))

url_dir_list = \
  ftp://$(gnu_rel_host)/gnu/coreutils

29 30 31
# We use .gnulib, not gnulib.
gnulib_dir = $(srcdir)/.gnulib

E
Eric Blake 已提交
32 33 34
# List of additional files that we want to pick up in our POTFILES.in
# This is all gnulib files, as well as generated files for RPC code.
generated_files = \
E
Eric Blake 已提交
35
  $(srcdir)/daemon/*_dispatch.h \
E
Eric Blake 已提交
36
  $(srcdir)/src/*/*_dispatch.h \
E
Eric Blake 已提交
37
  $(srcdir)/src/remote/*_client_bodies.h \
E
Eric Blake 已提交
38
  $(srcdir)/src/*/*_protocol.[ch] \
E
Eric Blake 已提交
39 40
  $(srcdir)/gnulib/lib/*.[ch]

E
Eric Blake 已提交
41 42 43
# We haven't converted all scripts to using gnulib's init.sh yet.
_test_script_regex = \<\(init\|test-lib\)\.sh\>

44 45
# Tests not to run as part of "make distcheck".
local-checks-to-skip =			\
46
  changelog-check			\
47
  makefile-check			\
48 49
  makefile_path_separator_check		\
  patch-check				\
50 51 52
  sc_GPL_version			\
  sc_always_defined_macros		\
  sc_cast_of_alloca_return_value	\
53
  sc_cross_check_PATH_usage_in_tests	\
54 55 56
  sc_dd_max_sym_length			\
  sc_error_exit_success			\
  sc_file_system			\
57 58
  sc_immutable_NEWS			\
  sc_makefile_path_separator_check	\
59
  sc_obsolete_symbols			\
60
  sc_prohibit_S_IS_definition		\
61
  sc_prohibit_atoi_atof			\
62
  sc_prohibit_hash_without_use		\
63 64 65
  sc_prohibit_jm_in_m4			\
  sc_prohibit_quote_without_use		\
  sc_prohibit_quotearg_without_use	\
66
  sc_prohibit_stat_st_blocks		\
67 68 69 70
  sc_root_tests				\
  sc_space_tab				\
  sc_sun_os_names			\
  sc_system_h_headers			\
E
Eric Blake 已提交
71
  sc_texinfo_acronym			\
72
  sc_tight_scope			\
73
  sc_two_space_separator_in_usage	\
J
Jim Meyering 已提交
74 75 76 77
  sc_error_message_uppercase		\
  sc_program_name			\
  sc_require_test_exit_idiom		\
  sc_makefile_check			\
78
  sc_useless_cpp_parens
79

80 81 82 83 84 85 86 87
# Most developers don't run 'make distcheck'.  We want the official
# dist to be secure, but don't want to penalize other developers
# using a distro that has not yet picked up the automake fix.
# FIXME remove this ifeq (making the syntax check unconditional)
# once fixed automake (1.11.6 or 1.12.2+) is more common.
ifeq ($(filter dist%, $(MAKECMDGOALS)), )
local-checks-to-skip +=	sc_vulnerable_makefile_CVE-2012-3386
else
88
distdir: sc_vulnerable_makefile_CVE-2012-3386.z
89 90
endif

91
# Files that should never cause syntax check failures.
92 93
VC_LIST_ALWAYS_EXCLUDE_REGEX = \
  (^(HACKING|docs/(news\.html\.in|.*\.patch))|\.po)$$
94 95

# Functions like free() that are no-ops on NULL arguments.
96
useless_free_options =				\
J
John Ferlan 已提交
97 98 99
  --name=VBOX_UTF16_FREE			\
  --name=VBOX_UTF8_FREE				\
  --name=VBOX_COM_UNALLOC_MEM			\
100
  --name=VIR_FREE				\
101
  --name=qemuCapsFree				\
102
  --name=qemuMigrationCookieFree                \
103
  --name=qemuMigrationCookieGraphicsFree        \
104
  --name=sexpr_free				\
105
  --name=usbFreeDevice                          \
106
  --name=virBandwidthDefFree			\
107
  --name=virBitmapFree                          \
108 109 110 111 112 113 114 115 116
  --name=virCPUDefFree				\
  --name=virCapabilitiesFree			\
  --name=virCapabilitiesFreeGuest		\
  --name=virCapabilitiesFreeGuestDomain		\
  --name=virCapabilitiesFreeGuestFeature	\
  --name=virCapabilitiesFreeGuestMachine	\
  --name=virCapabilitiesFreeHostNUMACell	\
  --name=virCapabilitiesFreeMachines		\
  --name=virCgroupFree				\
117
  --name=virCommandFree				\
118 119
  --name=virConfFreeList			\
  --name=virConfFreeValue			\
120
  --name=virDomainActualNetDefFree		\
121
  --name=virDomainChrDefFree			\
122
  --name=virDomainChrSourceDefFree		\
123 124 125 126 127 128 129
  --name=virDomainControllerDefFree		\
  --name=virDomainDefFree			\
  --name=virDomainDeviceDefFree			\
  --name=virDomainDiskDefFree			\
  --name=virDomainEventCallbackListFree		\
  --name=virDomainEventFree			\
  --name=virDomainEventQueueFree		\
130
  --name=virDomainEventStateFree		\
131 132 133 134 135 136
  --name=virDomainFSDefFree			\
  --name=virDomainGraphicsDefFree		\
  --name=virDomainHostdevDefFree		\
  --name=virDomainInputDefFree			\
  --name=virDomainNetDefFree			\
  --name=virDomainObjFree			\
E
Eric Blake 已提交
137
  --name=virDomainSmartcardDefFree		\
138 139 140 141 142
  --name=virDomainSnapshotDefFree		\
  --name=virDomainSnapshotObjFree		\
  --name=virDomainSoundDefFree			\
  --name=virDomainVideoDefFree			\
  --name=virDomainWatchdogDefFree		\
143
  --name=virFileDirectFdFree			\
144
  --name=virHashFree				\
145 146 147 148 149 150
  --name=virInterfaceDefFree			\
  --name=virInterfaceIpDefFree			\
  --name=virInterfaceObjFree			\
  --name=virInterfaceProtocolDefFree		\
  --name=virJSONValueFree			\
  --name=virLastErrFreeData			\
151
  --name=virNetMessageFree                      \
152 153 154
  --name=virNetServerMDNSFree                   \
  --name=virNetServerMDNSEntryFree              \
  --name=virNetServerMDNSGroupFree              \
155 156 157 158 159
  --name=virNWFilterDefFree			\
  --name=virNWFilterEntryFree			\
  --name=virNWFilterHashTableFree		\
  --name=virNWFilterIPAddrLearnReqFree		\
  --name=virNWFilterIncludeDefFree		\
160
  --name=virNWFilterObjFree			\
161 162 163 164 165 166
  --name=virNWFilterRuleDefFree			\
  --name=virNWFilterRuleInstFree		\
  --name=virNetworkDefFree			\
  --name=virNetworkObjFree			\
  --name=virNodeDeviceDefFree			\
  --name=virNodeDeviceObjFree			\
167 168
  --name=virObjectUnref                         \
  --name=virObjectFreeCallback                  \
169
  --name=virPCIDeviceFree                       \
170 171 172
  --name=virSecretDefFree			\
  --name=virStorageEncryptionFree		\
  --name=virStorageEncryptionSecretFree		\
173
  --name=virStorageFileFreeMetadata		\
174 175 176 177
  --name=virStoragePoolDefFree			\
  --name=virStoragePoolObjFree			\
  --name=virStoragePoolSourceFree		\
  --name=virStorageVolDefFree			\
H
Hu Tao 已提交
178
  --name=virThreadPoolFree			\
179
  --name=xmlBufferFree				\
180
  --name=xmlFree				\
181
  --name=xmlFreeDoc				\
E
Eric Blake 已提交
182
  --name=xmlFreeNode				\
183
  --name=xmlXPathFreeContext			\
184
  --name=xmlXPathFreeObject
185

186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226
# The following template was generated by this command:
# make ID && aid free|grep '^vi'|sed 's/ .*//;s/^/#   /'
# N virBufferFreeAndReset
# y virCPUDefFree
# y virCapabilitiesFree
# y virCapabilitiesFreeGuest
# y virCapabilitiesFreeGuestDomain
# y virCapabilitiesFreeGuestFeature
# y virCapabilitiesFreeGuestMachine
# y virCapabilitiesFreeHostNUMACell
# y virCapabilitiesFreeMachines
# N virCapabilitiesFreeNUMAInfo FIXME
# y virCgroupFree
# N virConfFree               (diagnoses the "error")
# y virConfFreeList
# y virConfFreeValue
# y virDomainChrDefFree
# y virDomainControllerDefFree
# y virDomainDefFree
# y virDomainDeviceDefFree
# y virDomainDiskDefFree
# y virDomainEventCallbackListFree
# y virDomainEventFree
# y virDomainEventQueueFree
# y virDomainFSDefFree
# n virDomainFree
# n virDomainFreeName (can't fix -- returns int)
# y virDomainGraphicsDefFree
# y virDomainHostdevDefFree
# y virDomainInputDefFree
# y virDomainNetDefFree
# y virDomainObjFree
# y virDomainSnapshotDefFree
# n virDomainSnapshotFree (returns int)
# n virDomainSnapshotFreeName (returns int)
# y virDomainSnapshotObjFree
# y virDomainSoundDefFree
# y virDomainVideoDefFree
# y virDomainWatchdogDefFree
# n virDrvNodeGetCellsFreeMemory (returns int)
# n virDrvNodeGetFreeMemory (returns long long)
E
Eric Blake 已提交
227
# n virFree - dereferences param
228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244
# n virFreeError
# n virHashFree (takes 2 args)
# y virInterfaceDefFree
# n virInterfaceFree (returns int)
# n virInterfaceFreeName
# y virInterfaceIpDefFree
# y virInterfaceObjFree
# n virInterfaceObjListFree
# y virInterfaceProtocolDefFree
# y virJSONValueFree
# y virLastErrFreeData
# y virNWFilterDefFree
# y virNWFilterEntryFree
# n virNWFilterFree (returns int)
# y virNWFilterHashTableFree
# y virNWFilterIPAddrLearnReqFree
# y virNWFilterIncludeDefFree
245 246 247
# n virNWFilterFreeName (returns int)
# y virNWFilterObjFree
# n virNWFilterObjListFree FIXME
248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281
# y virNWFilterRuleDefFree
# n virNWFilterRuleFreeInstanceData (typedef)
# y virNWFilterRuleInstFree
# y virNetworkDefFree
# n virNetworkFree (returns int)
# n virNetworkFreeName (returns int)
# y virNetworkObjFree
# n virNetworkObjListFree FIXME
# n virNodeDevCapsDefFree FIXME
# y virNodeDeviceDefFree
# n virNodeDeviceFree (returns int)
# y virNodeDeviceObjFree
# n virNodeDeviceObjListFree FIXME
# n virNodeGetCellsFreeMemory (returns int)
# n virNodeGetFreeMemory (returns non-void)
# y virSecretDefFree
# n virSecretFree (returns non-void)
# n virSecretFreeName (2 args)
# n virSecurityLabelDefFree FIXME
# n virStorageBackendDiskMakeFreeExtent (returns non-void)
# y virStorageEncryptionFree
# y virStorageEncryptionSecretFree
# n virStorageFreeType (enum)
# y virStoragePoolDefFree
# n virStoragePoolFree (returns non-void)
# n virStoragePoolFreeName (returns non-void)
# y virStoragePoolObjFree
# n virStoragePoolObjListFree FIXME
# y virStoragePoolSourceFree
# y virStorageVolDefFree
# n virStorageVolFree (returns non-void)
# n virStorageVolFreeName (returns non-void)
# n virStreamFree

282 283 284
# Avoid uses of write(2).  Either switch to streams (fwrite), or use
# the safewrite wrapper.
sc_avoid_write:
E
Eric Blake 已提交
285 286 287
	@prohibit='\<write *\('						\
	in_vc_files='\.c$$'						\
	halt='consider using safewrite instead of write'		\
288
	  $(_sc_search_regexp)
289

290 291 292
# In debug statements, print flags as bitmask and mode_t as octal.
sc_flags_debug:
	@prohibit='\<mode=%[0-9.]*[diux]'				\
293
	halt='use %o to debug mode_t values'				\
294
	  $(_sc_search_regexp)
295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310
	@prohibit='[Ff]lags=%[0-9.]*l*[diou]'				\
	halt='use %x to debug flag values'				\
	  $(_sc_search_regexp)

# Prefer 'unsigned int flags', along with checks for unknown flags.
# For historical reasons, we are stuck with 'unsigned long flags' in
# migration, so check for those known 4 instances and no more in public
# API.  Also check that no flags are marked unused, and 'unsigned' should
# appear before any declaration of a flags variable (achieved by
# prohibiting the word prior to the type from ending in anything other
# than d).  The existence of long long, and of documentation about
# flags, makes the regex in the third test slightly harder.
sc_flags_usage:
	@test "$$(cat $(srcdir)/include/libvirt/libvirt.h.in		\
	    $(srcdir)/include/libvirt/virterror.h			\
	    $(srcdir)/include/libvirt/libvirt-qemu.h			\
311
	    $(srcdir)/include/libvirt/libvirt-lxc.h			\
312 313 314 315 316 317 318 319
	  | grep -c '\(long\|unsigned\) flags')" != 4 &&		\
	  { echo '$(ME): new API should use "unsigned int flags"' 1>&2;	\
	    exit 1; } || :
	@prohibit=' flags ''ATTRIBUTE_UNUSED'				\
	halt='flags should be checked with virCheckFlags'		\
	  $(_sc_search_regexp)
	@prohibit='^[^@]*([^d] (int|long long)|[^dg] long) flags[;,)]'	\
	halt='flags should be unsigned'					\
320 321
	  $(_sc_search_regexp)

E
Eric Blake 已提交
322 323
# Avoid functions that should only be called via macro counterparts.
sc_prohibit_internal_functions:
324
	@prohibit='vir(Free|AllocN?|ReallocN|(Insert|Delete)ElementsN|File(Close|Fclose|Fdopen)) *\(' \
E
Eric Blake 已提交
325 326 327
	halt='use VIR_ macros instead of internal functions'		\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
328 329 330
# Avoid raw malloc and free, except in documentation comments.
sc_prohibit_raw_allocation:
	@prohibit='^.[^*].*\<((m|c|re)alloc|free) *\([^)]'		\
331
	halt='use VIR_ macros from viralloc.h instead of malloc/free'	\
E
Eric Blake 已提交
332 333
	  $(_sc_search_regexp)

E
Eric Blake 已提交
334 335
# Avoid functions that can lead to double-close bugs.
sc_prohibit_close:
336
	@prohibit='([^>.]|^)\<[fp]?close *\('				\
E
Eric Blake 已提交
337 338 339 340 341 342
	halt='use VIR_{FORCE_}[F]CLOSE instead of [f]close'		\
	  $(_sc_search_regexp)
	@prohibit='\<fdopen *\('					\
	halt='use VIR_FDOPEN instead of fdopen'				\
	  $(_sc_search_regexp)

343 344 345 346 347 348
# Prefer virCommand for all child processes.
sc_prohibit_fork_wrappers:
	@prohibit='= *\<(fork|popen|system) *\('			\
	halt='use virCommand for child processes'			\
	  $(_sc_search_regexp)

349 350 351 352 353 354
# Prefer mkostemp with O_CLOEXEC.
sc_prohibit_mkstemp:
	@prohibit='[^"]\<mkstemps? *\('					\
	halt='use mkostemp with O_CLOEXEC instead of mkstemp'		\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
355 356 357 358 359 360 361
# access with X_OK accepts directories, but we can't exec() those.
# access with F_OK or R_OK is okay, though.
sc_prohibit_access_xok:
	@prohibit='access''(at)? *\(.*X_OK'				\
	halt='use virFileIsExecutable instead of access''(,X_OK)'	\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
362 363
# Similar to the gnulib maint.mk rule for sc_prohibit_strcmp
# Use STREQLEN or STRPREFIX rather than comparing strncmp == 0, or != 0.
E
Eric Blake 已提交
364
snp_ = strncmp *\(.+\)
E
Eric Blake 已提交
365
sc_prohibit_strncmp:
E
Eric Blake 已提交
366 367
	@prohibit='! *strncmp *\(|\<$(snp_) *[!=]=|[!=]= *$(snp_)'	\
	exclude=':# *define STR(N?EQLEN|PREFIX)\('			\
368
	halt='use STREQLEN or STRPREFIX instead of str''ncmp'		\
E
Eric Blake 已提交
369
	  $(_sc_search_regexp)
370

E
Eric Blake 已提交
371 372 373 374
# strtol and friends are too easy to misuse
sc_prohibit_strtol:
	@prohibit='\bstrto(u?ll?|[ui]max) *\('				\
	exclude='exempt from syntax-check'				\
375
	halt='use virStrToLong_*, not strtol variants'			\
E
Eric Blake 已提交
376 377 378
	  $(_sc_search_regexp)
	@prohibit='\bstrto[df] *\('					\
	exclude='exempt from syntax-check'				\
379
	halt='use virStrToDouble, not strtod variants'			\
E
Eric Blake 已提交
380 381
	  $(_sc_search_regexp)

E
Eric Blake 已提交
382
# Use virAsprintf rather than as'printf since *strp is undefined on error.
E
Eric Blake 已提交
383
# But for plain %s, virAsprintf is overkill compared to strdup.
384
sc_prohibit_asprintf:
E
Eric Blake 已提交
385
	@prohibit='\<v?a[s]printf\>'					\
E
Eric Blake 已提交
386 387
	halt='use virAsprintf, not as'printf				\
	  $(_sc_search_regexp)
E
Eric Blake 已提交
388
	@prohibit='virAsprintf.*, *"%s",'				\
389 390 391 392 393 394
	halt='use VIR_STRDUP instead of virAsprintf with "%s"'		\
	  $(_sc_search_regexp)

sc_prohibit_strdup:
	@prohibit='\<strn?dup\> *\('					\
	halt='use VIR_STRDUP, not strdup'				\
E
Eric Blake 已提交
395
	  $(_sc_search_regexp)
E
Eric Blake 已提交
396

E
Eric Blake 已提交
397 398 399 400 401 402
# Prefer virSetUIDGID.
sc_prohibit_setuid:
	@prohibit='\<set(re)?[ug]id\> *\('				\
	halt='use virSetUIDGID, not raw set*id'				\
	  $(_sc_search_regexp)

403 404 405 406 407 408
# Don't compare *id_t against raw -1.
sc_prohibit_risky_id_promotion:
	@prohibit='\b(user|group|[ug]id) *[=!]= *-'			\
	halt='cast -1 to ([ug]id_t) before comparing against id'	\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
409 410 411 412 413
# Use snprintf rather than s'printf, even if buffer is provably large enough,
# since gnulib has more guarantees for snprintf portability
sc_prohibit_sprintf:
	@prohibit='\<[s]printf\>'					\
	halt='use snprintf, not s'printf				\
E
Eric Blake 已提交
414
	  $(_sc_search_regexp)
415

416
sc_prohibit_readlink:
417
	@prohibit='\<readlink *\('					\
E
Eric Blake 已提交
418 419
	halt='use virFileResolveLink, not readlink'			\
	  $(_sc_search_regexp)
420

421
sc_prohibit_gethostname:
E
Eric Blake 已提交
422 423 424
	@prohibit='gethostname *\('					\
	halt='use virGetHostname, not gethostname'			\
	  $(_sc_search_regexp)
425

E
Eric Blake 已提交
426
sc_prohibit_gettext_noop:
E
Eric Blake 已提交
427 428 429
	@prohibit='gettext_noop *\('					\
	halt='use N_, not gettext_noop'					\
	  $(_sc_search_regexp)
E
Eric Blake 已提交
430

431
sc_prohibit_VIR_ERR_NO_MEMORY:
E
Eric Blake 已提交
432 433 434
	@prohibit='\<V''IR_ERR_NO_MEMORY\>'				\
	halt='use virReportOOMError, not V'IR_ERR_NO_MEMORY		\
	  $(_sc_search_regexp)
435

436 437 438 439 440
sc_prohibit_PATH_MAX:
	@prohibit='\<P''ATH_MAX\>'				\
	halt='dynamically allocate paths, do not use P'ATH_MAX	\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
441
# Use a subshell for each function, to give the optimal warning message.
442
include $(srcdir)/Makefile.nonreentrant
443 444 445 446
sc_prohibit_nonreentrant:
	@fail=0 ; \
	for i in $(NON_REENTRANT) ; \
	do \
E
Eric Blake 已提交
447 448 449 450
	    (prohibit="\\<$$i *\\("					\
	     halt="use $${i}_r, not $$i"				\
	     $(_sc_search_regexp)					\
	    ) || fail=1;						\
451 452 453
	done ; \
	exit $$fail

454 455 456 457 458
sc_prohibit_select:
	@prohibit="\\<select *\\("					\
	halt="use poll(), not se""lect()"				\
	  $(_sc_search_regexp)

459 460
# Prohibit the inclusion of <ctype.h>.
sc_prohibit_ctype_h:
E
Eric Blake 已提交
461 462
	@prohibit='^# *include  *<ctype\.h>'				\
	halt="don't use ctype.h; instead, use c-ctype.h"		\
463
	  $(_sc_search_regexp)
464

465 466 467 468 469 470
# Insist on correct types for [pug]id.
sc_correct_id_types:
	@prohibit='\<(int|long) *[pug]id\>'				\
	halt="use pid_t for pid, uid_t for uid, gid_t for gid"		\
	  $(_sc_search_regexp)

471 472 473 474 475 476 477 478
# "const fooPtr a" is the same as "foo * const a", even though it is
# usually desired to have "foo const *a".  It's easier to just prevent
# the confusing mix of typedef vs. const placement.
sc_forbid_const_pointer_typedef:
	@prohibit='(^|[^"])const \w*Ptr'				\
	halt='"const fooPtr var" does not declare what you meant'	\
	  $(_sc_search_regexp)

479 480 481 482 483 484
# Forbid sizeof foo or sizeof (foo), require sizeof(foo)
sc_size_of_brackets:
	@prohibit='sizeof\s'						\
	halt='use sizeof(foo), not sizeof (foo) or sizeof foo'		\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
485
# Ensure that no C source file, docs, or rng schema uses TABs for
D
David Allan 已提交
486 487
# indentation.  Also match *.h.in files, to get libvirt.h.in.  Exclude
# files in gnulib, since they're imported.
488
space_indent_files=(\.(rng|s?[ch](\.in)?|html.in|py|pl|syms)|(daemon|tools)/.*\.in)
489
sc_TAB_in_indentation:
E
Eric Blake 已提交
490
	@prohibit='^ *	'						\
491
	in_vc_files='$(space_indent_files)$$'				\
492
	halt='indent with space, not TAB, in C, sh, html, py, syms and RNG schemas' \
493
	  $(_sc_search_regexp)
494 495 496 497 498

ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper

sc_avoid_ctype_macros:
E
Eric Blake 已提交
499 500
	@prohibit='\b($(ctype_re)) *\('					\
	halt="don't use ctype macros (use c-ctype.h)"			\
501
	  $(_sc_search_regexp)
502

503 504 505 506 507
sc_avoid_strcase:
	@prohibit='\bstrn?case(cmp|str) *\('				\
	halt="don't use raw strcase functions (use c-strcase instead)"	\
	  $(_sc_search_regexp)

508
sc_prohibit_virBufferAdd_with_string_literal:
E
Eric Blake 已提交
509 510 511
	@prohibit='\<virBufferAdd *\([^,]+, *"[^"]'			\
	halt='use virBufferAddLit, not virBufferAdd, with a string literal' \
	  $(_sc_search_regexp)
512

513 514 515 516 517
sc_prohibit_virBufferAsprintf_with_string_literal:
	@prohibit='\<virBufferAsprintf *\([^,]+, *"([^%"\]|\\.|%%)*"\)'		\
	halt='use virBufferAddLit, not virBufferAsprintf, with a string literal' \
	  $(_sc_search_regexp)

518 519 520
# Not only do they fail to deal well with ipv6, but the gethostby*
# functions are also not thread-safe.
sc_prohibit_gethostby:
E
Eric Blake 已提交
521 522 523
	@prohibit='\<gethostby(addr|name2?) *\('			\
	halt='use getaddrinfo, not gethostby*'				\
	  $(_sc_search_regexp)
524

525 526 527 528 529 530
# dirname and basename from <libgen.h> are not required to be thread-safe
sc_prohibit_libgen:
	@prohibit='( (base|dir)name *\(|include .libgen\.h)'		\
	halt='use functions from gnulib "dirname.h", not <libgen.h>'	\
	  $(_sc_search_regexp)

531 532 533 534 535 536
# raw xmlGetProp requires some nasty casts
sc_prohibit_xmlGetProp:
	@prohibit='\<xmlGetProp *\('					\
	halt='use virXMLPropString, not xmlGetProp'			\
	  $(_sc_search_regexp)

M
Martin Kletzander 已提交
537 538 539 540 541 542
# xml(ParseURI|SaveUri) doesn't handle IPv6 URIs well
sc_prohibit_xmlURI:
	@prohibit='\<xml(ParseURI|SaveUri) *\('				\
	halt='use virURI(Parse|Format), not xml(ParseURI|SaveUri)'	\
	  $(_sc_search_regexp)

543 544 545 546 547 548
# we don't want old old-style return with parentheses around argument
sc_prohibit_return_as_function:
	@prohibit='\<return *\(([^()]*(\([^()]*\)[^()]*)*)\) *;'    \
	halt='avoid extra () with return statements'                \
	  $(_sc_search_regexp)

549 550 551 552 553 554 555 556
# ATTRIBUTE_UNUSED should only be applied in implementations, not
# header declarations
sc_avoid_attribute_unused_in_header:
	@prohibit='^[^#]*ATTRIBUTE_UNUSED([^:]|$$)'			\
	in_vc_files='\.h$$'						\
	halt='use ATTRIBUTE_UNUSED in .c rather than .h files'		\
	  $(_sc_search_regexp)

557
sc_prohibit_int_ijk:
E
Eric Blake 已提交
558
	@prohibit='\<(int|unsigned) ([^(]* )*(i|j|k)(\s|,|;)'		\
559 560 561 562
	halt='use size_t, not int/unsigned int for loop vars i, j, k'	\
	  $(_sc_search_regexp)

sc_prohibit_loop_iijjkk:
E
Eric Blake 已提交
563 564
	@prohibit='\<(int|unsigned) ([^=]+ )*(ii|jj|kk)(\s|,|;)'	\
	halt='use i, j, k for loop iterators, not ii, jj, kk' 		\
565 566
	  $(_sc_search_regexp)

E
Eric Blake 已提交
567 568 569 570 571 572
# RHEL 5 gcc can't grok "for (int i..."
sc_prohibit_loop_var_decl:
	@prohibit='\<for *\(\w+[ *]+\w+'				\
	in_vc_files='\.[ch]$$'						\
	halt='declare loop iterators outside the for statement'		\
	  $(_sc_search_regexp)
573

574 575 576 577 578 579
# Many of the function names below came from this filter:
# git grep -B2 '\<_('|grep -E '\.c- *[[:alpha:]_][[:alnum:]_]* ?\(.*[,;]$' \
# |sed 's/.*\.c-  *//'|perl -pe 's/ ?\(.*//'|sort -u \
# |grep -vE '^(qsort|if|close|assert|fputc|free|N_|vir.*GetName|.*Unlock|virNodeListDevices|virHashRemoveEntry|freeaddrinfo|.*[fF]ree|xdrmem_create|xmlXPathFreeObject|virUUIDFormat|openvzSetProgramSentinal|polkit_action_unref)$'

msg_gen_function =
580
msg_gen_function += VIR_ERROR
581 582
msg_gen_function += lxcError
msg_gen_function += regerror
583 584
msg_gen_function += vah_error
msg_gen_function += vah_warning
585
msg_gen_function += virGenericReportError
586 587
msg_gen_function += virLibConnError
msg_gen_function += virLibDomainError
588 589 590 591 592 593 594 595
msg_gen_function += virLibDomainSnapshotError
msg_gen_function += virLibInterfaceError
msg_gen_function += virLibNetworkError
msg_gen_function += virLibNodeDeviceError
msg_gen_function += virLibNWFilterError
msg_gen_function += virLibSecretError
msg_gen_function += virLibStoragePoolError
msg_gen_function += virLibStorageVolError
596
msg_gen_function += virRaiseError
597
msg_gen_function += virReportError
598 599
msg_gen_function += virReportErrorHelper
msg_gen_function += virReportSystemError
600
msg_gen_function += xenapiSessionErrorHandler
601 602 603 604 605 606 607 608 609

# Uncomment the following and run "make syntax-check" to see diagnostics
# that are not yet marked for translation, but that need to be rewritten
# so that they are translatable.
# msg_gen_function += fprintf
# msg_gen_function += testError
# msg_gen_function += vshPrint
# msg_gen_function += vshError

610
func_or := $(shell echo $(msg_gen_function)|tr -s ' ' '|')
611 612 613 614 615 616 617 618
func_re := ($(func_or))

# Look for diagnostics that aren't marked for translation.
# This won't find any for which error's format string is on a separate line.
# The sed filters eliminate false-positives like these:
#    _("...: "
#    "%s", _("no storage vol w..."
sc_libvirt_unmarked_diagnostics:
E
Eric Blake 已提交
619 620
	@prohibit='\<$(func_re) *\([^"]*"[^"]*[a-z]{3}'			\
	exclude='_\('							\
621
	halt='found unmarked diagnostic(s)'				\
E
Eric Blake 已提交
622
	  $(_sc_search_regexp)
623 624
	@{ grep     -nE '\<$(func_re) *\(.*;$$' $$($(VC_LIST_EXCEPT));   \
	   grep -A1 -nE '\<$(func_re) *\(.*,$$' $$($(VC_LIST_EXCEPT)); } \
625
	   | sed 's/_("\([^\"]\|\\.\)\+"//;s/[	 ]"%s"//'		\
626 627 628
	   | grep '[	 ]"' &&						\
	  { echo '$(ME): found unmarked diagnostic(s)' 1>&2;		\
	    exit 1; } || :
629

630 631 632 633 634 635 636 637 638 639 640 641 642 643
# Like the above, but prohibit a newline at the end of a diagnostic.
# This is subject to false positives partly because it naively looks for
# `\n"', which may not be the end of the string, and also because it takes
# two lines of context (the -A2) after the line with the function name.
# FIXME: this rule might benefit from a separate function list, in case
# there are functions to which this one applies but that do not get marked
# diagnostics.
sc_prohibit_newline_at_end_of_diagnostic:
	@grep -A2 -nE							\
	    '\<$(func_re) *\(' $$($(VC_LIST_EXCEPT))			\
	    | grep '\\n"'						\
	  && { echo '$(ME): newline at end of message(s)' 1>&2;		\
	    exit 1; } || :

644 645 646 647 648 649 650 651 652 653 654 655 656
# Look for diagnostics that lack a % in the format string, except that we
# allow VIR_ERROR to do this, and ignore functions that take a single
# string rather than a format argument.
sc_prohibit_diagnostic_without_format:
	@{ grep     -nE '\<$(func_re) *\(.*;$$' $$($(VC_LIST_EXCEPT));   \
	   grep -A2 -nE '\<$(func_re) *\(.*,$$' $$($(VC_LIST_EXCEPT)); } \
	   | sed -rn -e ':l; /[,"]$$/ {N;b l;}'				 \
		-e '/(xenapiSessionErrorHandler|vah_(error|warning))/d'	 \
		-e '/\<$(func_re) *\([^"]*"([^%"]|"\n[^"]*")*"[,)]/p'	 \
           | grep -vE 'VIR_ERROR' &&					 \
	  { echo '$(ME): found diagnostic without %' 1>&2;		 \
	    exit 1; } || :

657
# The strings "" and "%s" should never be marked for translation.
658
# Files under tests/ and examples/ should not be translated.
659 660
sc_prohibit_useless_translation:
	@prohibit='_\("(%s)?"\)'					\
661 662 663 664 665
	halt='found useless translation'				\
	  $(_sc_search_regexp)
	@prohibit='\<N?_ *\('						\
	in_vc_files='^(tests|examples)/'				\
	halt='no translations in tests or examples'			\
666 667
	  $(_sc_search_regexp)

668 669 670 671 672 673 674 675 676
# When splitting a diagnostic across lines, ensure that there is a space
# or \n on one side of the split.
sc_require_whitespace_in_translation:
	@grep -n -A1 '"$$' $$($(VC_LIST_EXCEPT))   			\
	   | sed -ne ':l; /"$$/ {N;b l;}; s/"\n[^"]*"/""/g; s/\\n/ /g'	\
		-e '/_(.*[^\ ]""[^\ ]/p' | grep . &&			\
	  { echo '$(ME): missing whitespace at line split' 1>&2;	\
	    exit 1; } || :

677 678
# Enforce recommended preprocessor indentation style.
sc_preprocessor_indentation:
679
	@if cppi --version >/dev/null 2>&1; then			\
680
	  $(VC_LIST_EXCEPT) | grep '\.[ch]$$' | xargs cppi -a -c	\
681 682 683 684 685 686
	    || { echo '$(ME): incorrect preprocessor indentation' 1>&2;	\
		exit 1; };						\
	else								\
	  echo '$(ME): skipping test $@: cppi not installed' 1>&2;	\
	fi

687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703
# Enforce similar spec file indentation style, by running cppi on a
# (comment-only) C file that mirrors the same layout as the spec file.
sc_spec_indentation:
	@if cppi --version >/dev/null 2>&1; then			\
	  for f in $$($(VC_LIST_EXCEPT) | grep '\.spec\.in$$'); do	\
	    sed -e 's|#|// #|; s|%ifn*\(arch\)* |#if a // |'		\
		-e 's/%\(else\|endif\|define\)/#\1/'			\
		-e 's/^\( *\)\1\1\1#/#\1/'				\
		-e 's|^\( *[^#/ ]\)|// \1|; s|^\( */[^/]\)|// \1|' $$f	\
	    | cppi -a -c 2>&1 | sed "s|standard input|$$f|";		\
	  done | { if grep . >&2; then false; else :; fi; }		\
	    || { echo '$(ME): incorrect preprocessor indentation' 1>&2;	\
		exit 1; };						\
	else								\
	  echo '$(ME): skipping test $@: cppi not installed' 1>&2;	\
	fi

704 705 706 707 708 709 710 711
# Nested conditionals are easier to understand if we enforce that endifs
# can be paired back to the if
sc_makefile_conditionals:
	@prohibit='(else|endif)($$| *#)'				\
	in_vc_files='Makefile\.am'					\
	halt='match "if FOO" with "endif FOO" in Makefiles'		\
	  $(_sc_search_regexp)

E
Eric Blake 已提交
712 713 714 715 716 717 718 719
# Long lines can be harder to diff; too long, and git send-email chokes.
# For now, only enforce line length on files where we have intentionally
# fixed things and don't want to regress.
sc_prohibit_long_lines:
	@prohibit='.{90}'						\
	in_vc_files='\.arg[sv]'						\
	halt='Wrap long lines in expected output files'			\
	  $(_sc_search_regexp)
720 721 722 723
	@prohibit='.{80}'						\
	in_vc_files='Makefile\.am'					\
	halt='Wrap long lines in Makefiles'				\
	  $(_sc_search_regexp)
E
Eric Blake 已提交
724

725
sc_copyright_format:
E
Eric Blake 已提交
726 727 728
	@require='Copyright .*Red 'Hat', Inc\.'				\
	containing='Copyright .*Red 'Hat				\
	halt='Red Hat copyright is missing Inc.'			\
729
	  $(_sc_search_regexp)
E
Eric Blake 已提交
730 731
	@prohibit='Copyright [^(].*Red 'Hat				\
	halt='consistently use (C) in Red Hat copyright'		\
732
	  $(_sc_search_regexp)
E
Eric Blake 已提交
733 734 735
	@prohibit='\<Red''Hat\>'					\
	halt='spell Red Hat as two words'				\
	  $(_sc_search_regexp)
736

737
# Prefer the new URL listing over the old street address listing when
738 739 740 741 742 743
# calling out where to get a copy of the [L]GPL.  Also, while we have
# to ship COPYING (GPL) alongside COPYING.LESSER (LGPL), we want any
# source file that calls out a top-level file to call out the LGPL
# version.  Note that our typical copyright boilerplate refers to the
# license by name, not by reference to a top-level file.
sc_copyright_usage:
744 745 746
	@prohibit=Boston,' MA'						\
	halt='Point to <http://www.gnu.org/licenses/>, not an address'	\
	  $(_sc_search_regexp)
747 748 749 750 751 752 753
	@require='COPYING\.LESSER'					\
	containing='COPYING'						\
	halt='Refer to COPYING.LESSER for LGPL'				\
	  $(_sc_search_regexp)
	@prohibit='COPYING\.LIB'					\
	halt='Refer to COPYING.LESSER for LGPL'				\
	  $(_sc_search_regexp)
754

755 756 757
# Some functions/macros produce messages intended solely for developers
# and maintainers.  Do not mark them for translation.
sc_prohibit_gettext_markup:
758
	@prohibit='\<VIR_(WARN|INFO|DEBUG) *\(_\('			\
759 760
	halt='do not mark these strings for translation'		\
	  $(_sc_search_regexp)
761

E
Eric Blake 已提交
762 763 764 765 766 767 768 769
# Our code is divided into modular subdirectories for a reason, and
# lower-level code must not include higher-level headers.
cross_dirs=$(patsubst $(srcdir)/src/%.,%,$(wildcard $(srcdir)/src/*/.))
cross_dirs_re=($(subst / ,/|,$(cross_dirs)))
sc_prohibit_cross_inclusion:
	@for dir in $(cross_dirs); do					\
	  case $$dir in							\
	    util/) safe="util";;					\
770 771
	    locking/)							\
	      safe="($$dir|util|conf|rpc)";;				\
E
Eric Blake 已提交
772 773 774 775 776 777 778 779 780 781 782 783
	    cpu/ | locking/ | network/ | rpc/ | security/)		\
	      safe="($$dir|util|conf)";;				\
	    xenapi/ | xenxs/ ) safe="($$dir|util|conf|xen)";;		\
	    *) safe="($$dir|util|conf|cpu|network|locking|rpc|security)";; \
	  esac;								\
	  in_vc_files="^src/$$dir"					\
	  prohibit='^# *include .$(cross_dirs_re)'			\
	  exclude="# *include .$$safe"					\
	  halt='unsafe cross-directory include'				\
	    $(_sc_search_regexp)					\
	done

E
Eric Blake 已提交
784 785 786 787 788 789 790 791 792 793 794
# When converting an enum to a string, make sure that we track any new
# elements added to the enum by using a _LAST marker.
sc_require_enum_last_marker:
	@grep -A1 -nE '^[^#]*VIR_ENUM_IMPL *\(' $$($(VC_LIST_EXCEPT))	\
	   | sed -ne '/VIR_ENUM_IMPL[^,]*,$$/N'				\
	     -e '/VIR_ENUM_IMPL[^,]*,[^,]*[^_,][^L,][^A,][^S,][^T,],/p'	\
	     -e '/VIR_ENUM_IMPL[^,]*,[^,]\{0,4\},/p'			\
	   | grep . &&							\
	  { echo '$(ME): enum impl needs to use _LAST marker' 1>&2;	\
	    exit 1; } || :

795 796 797 798 799 800 801
# In Python files we don't want to end lines with a semicolon like in C
sc_prohibit_semicolon_at_eol_in_python:
	@prohibit='^[^#].*\;$$'			                        \
	in_vc_files='\.py$$'						\
	halt="Don't use semicolon at eol in python files"		\
	  $(_sc_search_regexp)

802 803 804 805 806 807 808
# mymain() in test files should use return, not exit, for nicer output
sc_prohibit_exit_in_tests:
	@prohibit='\<exit *\('						\
	in_vc_files='^tests/'						\
	halt='use return, not exit(), in tests'				\
	  $(_sc_search_regexp)

809 810 811 812 813 814 815 816 817 818 819 820 821 822 823 824 825 826 827 828 829
# Don't include duplicate header in the source (either *.c or *.h)
sc_prohibit_duplicate_header:
	@fail=0; for i in $$($(VC_LIST_EXCEPT) | grep '\.[chx]$$'); do	\
	  awk '/# *include.*\.h/ {					\
	    match($$0, /[<"][^>"]*[">]/);				\
	    arr[substr($$0, RSTART + 1, RLENGTH - 2)]++;		\
	  }								\
	  END {								\
	    for (key in arr) {						\
	      if (arr[key] > 1)	{					\
		fail=1;							\
		printf("%d %s are included\n", arr[key], key);		\
	      }								\
	    }								\
	    if (fail == 1) {						\
	      printf("duplicate header(s) in " FILENAME "\n");		\
	      exit 1;							\
	    }								\
	  }' $$i || fail=1;						\
	done;								\
	if test $$fail -eq 1; then					\
830
	  { echo '$(ME): avoid duplicate headers' 1>&2; exit 1; }	\
831 832
	fi;

833
# Don't include "libvirt/*.h" in "" form.
834
sc_prohibit_include_public_headers_quote:
835
	@prohibit='# *include *"libvirt/.*\.h"'				\
836 837 838 839 840 841 842 843 844
	in_vc_files='\.[ch]$$'						\
	halt='Do not include libvirt/*.h in internal source'		\
	  $(_sc_search_regexp)

# Don't include "libvirt/*.h" in <> form. Except for external tools,
# e.g. Python binding, examples and tools subdirectories.
sc_prohibit_include_public_headers_brackets:
	@prohibit='# *include *<libvirt/.*\.h>'				\
	in_vc_files='\.[ch]$$'						\
845 846 847
	halt='Do not include libvirt/*.h in internal source'		\
	  $(_sc_search_regexp)

848 849 850 851 852 853 854 855
# <config.h> is only needed in .c files; .h files do not need it since
# .c files must include config.h before any other .h.
sc_prohibit_config_h_in_headers:
	@prohibit='^# *include\>.*config\.h'				\
	in_vc_files='\.h$$'						\
	halt='headers should not include <config.h>'			\
	  $(_sc_search_regexp)

856 857 858 859 860 861
sc_prohibit_unbounded_arrays_in_rpc:
	@prohibit='<>'							\
	in_vc_files='\.x$$'						\
	halt='Arrays in XDR must have a upper limit set for <NNN>'	\
	  $(_sc_search_regexp)

862

863 864
# We don't use this feature of maint.mk.
prev_version_file = /dev/null
865 866 867

ifeq (0,$(MAKELEVEL))
  _curr_status = .git-module-status
868 869 870 871 872 873
  # The sed filter accommodates those who check out on a commit from which
  # no tag is reachable.  In that case, git submodule status prints a "-"
  # in column 1 and does not print a "git describe"-style string after the
  # submodule name.  Contrast these:
  # -b653eda3ac4864de205419d9f41eec267cb89eeb .gnulib
  #  b653eda3ac4864de205419d9f41eec267cb89eeb .gnulib (v0.0-2286-gb653eda)
874 875
  # $ cat .git-module-status
  # b653eda3ac4864de205419d9f41eec267cb89eeb
876 877
  #
  # Keep this logic in sync with autogen.sh.
878
  _submodule_hash = sed 's/^[ +-]//;s/ .*//'
879
  _update_required := $(shell						\
880
      cd '$(srcdir)';							\
881
      test -d .git || { echo 0; exit; };				\
882
      test -f po/Makevars || { echo 1; exit; };				\
883
      test -f AUTHORS || { echo 1; exit; };				\
E
Eric Blake 已提交
884
      test "no-git" = "$$(cat $(_curr_status))" && { echo 0; exit; };	\
885
      actual=$$(git submodule status | $(_submodule_hash);		\
886
		git hash-object bootstrap.conf;				\
E
Eric Blake 已提交
887
		git ls-tree -d HEAD gnulib/local | awk '{print $$3}';	\
888
		git diff .gnulib);					\
889 890
      stamp="$$($(_submodule_hash) $(_curr_status) 2>/dev/null)";	\
      test "$$stamp" = "$$actual"; echo $$?)
891 892
  _clean_requested = $(filter %clean,$(MAKECMDGOALS))
  ifeq (1,$(_update_required)$(_clean_requested))
893
    $(info INFO: gnulib update required; running ./autogen.sh first)
C
Cole Robinson 已提交
894
    $(shell touch $(srcdir)/AUTHORS $(srcdir)/ChangeLog)
E
Eric Blake 已提交
895
maint.mk Makefile: _autogen
896 897
  endif
endif
898

E
Eric Blake 已提交
899 900 901 902 903 904 905
# It is necessary to call autogen any time gnulib changes.  Autogen
# reruns configure, then we regenerate all Makefiles at once.
.PHONY: _autogen
_autogen:
	$(srcdir)/autogen.sh
	./config.status

906
# regenerate HACKING as part of the syntax-check
907 908 909 910 911
syntax-check: $(top_srcdir)/HACKING bracket-spacing-check

bracket-spacing-check:
	$(AM_V_GEN)files=`$(VC_LIST) | grep '\.c$$'`; \
	$(PERL) $(top_srcdir)/build-aux/bracket-spacing.pl $$files || \
912
	  { echo '$(ME): incorrect whitespace, see HACKING for rules' 1>&2; \
913
	    exit 1; }
914

915
# sc_po_check can fail if generated files are not built first
916 917 918
sc_po_check: \
		$(srcdir)/daemon/remote_dispatch.h \
		$(srcdir)/daemon/qemu_dispatch.h \
919
		$(srcdir)/src/remote/remote_client_bodies.h
920
$(srcdir)/daemon/remote_dispatch.h: $(srcdir)/src/remote/remote_protocol.x
921
	$(MAKE) -C daemon remote_dispatch.h
922 923 924
$(srcdir)/daemon/qemu_dispatch.h: $(srcdir)/src/remote/qemu_protocol.x
	$(MAKE) -C daemon qemu_dispatch.h
$(srcdir)/src/remote/remote_client_bodies.h: $(srcdir)/src/remote/remote_protocol.x
925 926
	$(MAKE) -C src remote/remote_client_bodies.h

927
# List all syntax-check exemptions:
928
exclude_file_name_regexp--sc_avoid_strcase = ^tools/virsh\.h$$
929

930
_src1=libvirt|fdstream|qemu/qemu_monitor|util/(vircommand|virfile)|xen/xend_internal|rpc/virnetsocket|lxc/lxc_controller|locking/lock_daemon
931
_test1=shunloadtest|virnettlscontexttest|virnettlssessiontest|vircgroupmock
932
exclude_file_name_regexp--sc_avoid_write = \
933
  ^(src/($(_src1))|daemon/libvirtd|tools/virsh-console|tests/($(_test1)))\.c$$
934 935 936

exclude_file_name_regexp--sc_bindtextdomain = ^(tests|examples)/

937
exclude_file_name_regexp--sc_copyright_usage = \
938
  ^COPYING(|\.LESSER)$$
939

940
exclude_file_name_regexp--sc_flags_usage = ^(docs/|src/util/virnetdevtap\.c$$|tests/vircgroupmock\.c$$)
941

942
exclude_file_name_regexp--sc_libvirt_unmarked_diagnostics = \
943
  ^(src/rpc/gendispatch\.pl$$|tests/)
944

945
exclude_file_name_regexp--sc_po_check = ^(docs/|src/rpc/gendispatch\.pl$$)
946 947

exclude_file_name_regexp--sc_prohibit_VIR_ERR_NO_MEMORY = \
948
  ^(include/libvirt/virterror\.h|daemon/dispatch\.c|src/util/virerror\.c)$$
949

950
exclude_file_name_regexp--sc_prohibit_access_xok = ^src/util/virutil\.c$$
E
Eric Blake 已提交
951

952
exclude_file_name_regexp--sc_prohibit_always_true_header_tests = \
953
  ^python/(libvirt-(lxc-|qemu-)?override|typewrappers)\.c$$
954 955

exclude_file_name_regexp--sc_prohibit_asprintf = \
956
  ^(bootstrap.conf$$|src/util/virstring\.[ch]$$|examples/domain-events/events-c/event-test\.c$$|tests/vircgroupmock\.c$$)
E
Eric Blake 已提交
957

958
exclude_file_name_regexp--sc_prohibit_strdup = \
959
  ^(docs/|examples/|python/|src/util/virstring\.c|tests/virnetserverclientmock.c$$)
960

961
exclude_file_name_regexp--sc_prohibit_close = \
962
  (\.p[yl]$$|^docs/|^(src/util/virfile\.c|src/libvirt\.c|tests/vircgroupmock\.c)$$)
963 964

exclude_file_name_regexp--sc_prohibit_empty_lines_at_EOF = \
E
Eric Blake 已提交
965
  (^tests/(qemuhelp|nodeinfo)data/|\.(gif|ico|png|diff)$$)
966

967
_src2=src/(util/vircommand|libvirt|lxc/lxc_controller|locking/lock_daemon)
968
exclude_file_name_regexp--sc_prohibit_fork_wrappers = \
969
  (^($(_src2)|tests/testutils|daemon/libvirtd)\.c$$)
970

971
exclude_file_name_regexp--sc_prohibit_gethostname = ^src/util/virutil\.c$$
972

E
Eric Blake 已提交
973
exclude_file_name_regexp--sc_prohibit_internal_functions = \
974
  ^src/(util/(viralloc|virutil|virfile)\.[hc]|esx/esx_vi\.c)$$
E
Eric Blake 已提交
975

976
exclude_file_name_regexp--sc_prohibit_newline_at_end_of_diagnostic = \
977
  ^src/rpc/gendispatch\.pl$$
978

979
exclude_file_name_regexp--sc_prohibit_nonreentrant = \
980
  ^((po|tests)/|docs/.*(py|html\.in)|run.in$$)
981

E
Eric Blake 已提交
982
exclude_file_name_regexp--sc_prohibit_raw_allocation = \
983
  ^(docs/hacking\.html\.in)|(src/util/viralloc\.[ch]|examples/.*|tests/securityselinuxhelper\.c|tests/vircgroupmock\.c)$$
E
Eric Blake 已提交
984

985
exclude_file_name_regexp--sc_prohibit_readlink = \
986
  ^src/(util/virutil|lxc/lxc_container)\.c$$
987

988
exclude_file_name_regexp--sc_prohibit_setuid = ^src/util/virutil\.c$$
E
Eric Blake 已提交
989

990
exclude_file_name_regexp--sc_prohibit_sprintf = \
991
  ^(docs/hacking\.html\.in)|(examples/systemtap/.*stp)|(src/dtrace2systemtap\.pl)|(src/rpc/gensystemtap\.pl)$$
992

993
exclude_file_name_regexp--sc_prohibit_strncpy = ^src/util/virstring\.c$$
994

E
Eric Blake 已提交
995
exclude_file_name_regexp--sc_prohibit_strtol = \
996
  ^src/(util/virsexpr|(vbox|xen|xenxs)/.*)\.c$$
E
Eric Blake 已提交
997

998
exclude_file_name_regexp--sc_prohibit_xmlGetProp = ^src/util/virxml\.c$$
999

M
Martin Kletzander 已提交
1000 1001
exclude_file_name_regexp--sc_prohibit_xmlURI = ^src/util/viruri\.c$$

1002 1003
exclude_file_name_regexp--sc_prohibit_return_as_function = \.py$$

1004 1005
exclude_file_name_regexp--sc_require_config_h = \
	^(examples/|tools/virsh-edit\.c$$)
1006

1007 1008
exclude_file_name_regexp--sc_require_config_h_first = \
	^(examples/|tools/virsh-edit\.c$$)
1009

1010
exclude_file_name_regexp--sc_trailing_blank = \
V
Viktor Mihajlovski 已提交
1011
  (/qemuhelpdata/|/sysinfodata/.*\.data|\.(fig|gif|ico|png)$$)
1012 1013 1014

exclude_file_name_regexp--sc_unmarked_diagnostics = \
  ^(docs/apibuild.py|tests/virt-aa-helper-test)$$
1015 1016

exclude_file_name_regexp--sc_size_of_brackets = cfg.mk
1017 1018 1019

exclude_file_name_regexp--sc_correct_id_types = \
  (^src/locking/lock_protocol.x$$)
1020 1021

exclude_file_name_regexp--sc_m4_quote_check = m4/virt-lib.m4
1022

1023 1024 1025 1026 1027
exclude_file_name_regexp--sc_prohibit_include_public_headers_quote = \
  ^src/internal\.h$$

exclude_file_name_regexp--sc_prohibit_include_public_headers_brackets = \
  ^(python/|tools/|examples/|include/libvirt/(virterror|libvirt-(qemu|lxc))\.h$$)
1028 1029 1030

exclude_file_name_regexp--sc_prohibit_int_ijk = \
  ^(src/remote_protocol-structs|src/remote/remote_protocol.x|cfg.mk|include/)$